#include <fstream>
#include <iostream>
#include <string.h>
using namespace std;

const int MAXL = 100;
const int MAXN = 50;

struct Iscrizione {
  char nome[MAXL];
  int matricola;
  int votoScritto;
};

struct CodaIscr { 
  int front, back;
  Iscrizione iscr[MAXN];
};

int inserisci(CodaIscr* pc, char n[], int m, int v) ;
bool scambia(CodaIscr* pc, int a, int b) ;
bool salva(const CodaIscr *pc, const char nf[]) ;
bool controlla(const CodaIscr* pc) ;
bool votoPiuAlto(const CodaIscr* pc, Iscrizione* pi);

void stampa(const CodaIscr* pc){
  for(int i=pc->front; i!=pc->back; i=(i+1)%MAXN)
    cout << pc->iscr[i].nome << ", " 
         << pc->iscr[i].matricola << ", " 
         << pc->iscr[i].votoScritto << endl;
}

int main(){
  CodaIscr ci;
  ci.front = ci.back = 0;
  int pos = inserisci(&ci, "Mario Rossi", 123321, 23);  
  cout << "Mario Rossi inserito in posizione " << pos << endl;
  pos = inserisci(&ci, "Giulia Bianchi", 454545, 27);  
  cout << "Giulia Bianchi inserita in posizione " << pos << endl;
  pos = inserisci(&ci, "Luigi Verdi", 347823, 18);  
  cout << "Luigi Verdi inserito in posizione " << pos << endl;
  pos = inserisci(&ci, "Sara Gialli", 246533, 29);  
  cout << "Sara Gialli inserita in posizione " << pos << endl;
  pos = inserisci(&ci, "Ernesto Sgambelluri", 306578, 30);  
  cout << "Ernesto Sgambelluri inserito in posizione " << pos << endl;
  cout << "Adesso il contenuto della coda e': " << endl;
  stampa(&ci);
  system("pause");

  int na = 306578, nb = 123321;
  cout << "Gli studenti con n. matr. " << na << " e " 
       << nb << " vogliono scambiare le loro posizioni" << endl;
  bool ris = scambia(&ci, na, nb);
  cout << "Scambio " << (ris ? "" : " non ") << "riuscito" << endl;
  na = 454545; nb = 432423;
  cout << "Gli studenti con n. matr. " << na << " e " 
       << nb << " vogliono scambiare le loro posizioni" << endl;
  ris = scambia(&ci, na, nb);
  cout << "Scambio " << (ris ? "" : " non ") << "riuscito" << endl;
  cout << "Adesso il contenuto della coda e': " << endl;
  stampa(&ci);
  system("pause");

  cout << "Provo a salvare la coda nel file prova.txt" << endl;
  if(!salva(&ci, "prova.txt")) 
    cout << "Problemi nel salvataggio" << endl;
  cout << "Il contenuto del file prova.txt e': " << endl;
  system("type prova.txt");

  cout << "Controllo se ci sono due iscrizioni con lo stesso n. di matricola" << endl;
  if(!controlla(&ci))
    cout << "Ci sono due iscrizioni con lo stesso n. di matricola" << endl;
  else 
    cout << "Tutto ok" << endl;
  cout << "Inserisco Giacomo Tombino, n. matr 347823, voto 20" << endl;
  pos = inserisci(&ci, "Giacomo Tombino", 347823, 20);  
  cout << "Adesso il contenuto della coda e': " << endl;
  stampa(&ci);
  system("pause");
  cout << "Controllo se ci sono due iscrizioni con lo stesso n. di matricola" << endl;
  if(!controlla(&ci))
    cout << "Ci sono due iscrizioni con lo stesso n. di matricola" << endl;
  else 
    cout << "Tutto ok" << endl;
  system("pause");
  
  cout << "Cerco l'iscrizione con il voto piu' alto:" << endl;
  Iscrizione is;
  if(votoPiuAlto(&ci, &is)) 
    cout << is.nome << ", " << is.matricola << ", " << is.votoScritto << endl;
  else cout << "Coda vuota" << endl;
  system("pause");
  return 0;
}
