#include <fstream>
#include <string.h>
using namespace std;

const int MAXL = 100;
const int MAXN = 50;

struct Iscrizione {
  char nome[MAXL];
  int matricola;
  int votoScritto;
};

struct CodaIscr { 
  int front, back;
  Iscrizione iscr[MAXN];
};

bool full(const CodaIscr* pc) {
  if((pc->back + 1) % MAXN == pc->front)
    return true;
  return false;
}

int inserisci(CodaIscr* pc, char n[], int m, int v) {
  if(full(pc))
    return -1;
  strcpy(pc->iscr[pc->back].nome, n);
  pc->iscr[pc->back].matricola = m;
  pc->iscr[pc->back].votoScritto = v;
  pc->back = (pc->back + 1) % MAXN;
  return (pc->back + MAXN - pc->front) % MAXN;
}

int trova(const CodaIscr *pc, int n) {
  for(int i=pc->front; i!=pc->back; i = (i+1) % MAXN)
    if(pc->iscr[i].matricola == n)
      return i;
  return -1;
}

bool scambia(CodaIscr* pc, int a, int b) {
  int posa = trova(pc, a);
  int posb = trova(pc, b);
  if(posa == -1 || posb == -1)
    return false;
  Iscrizione tmp = pc->iscr[posa];
  pc->iscr[posa] = pc->iscr[posb];
  pc->iscr[posb] = tmp;
  return true;
}

bool salva(const CodaIscr *pc, const char nf[]) {
  fstream ff;
  ff.open(nf, ios::out);
  if(!ff)
    return false;
  for(int i=pc->front; i!=pc->back; i=(i+1)%MAXN)
    ff << pc->iscr[i].nome << ", " 
       << pc->iscr[i].matricola << ", " 
       << pc->iscr[i].votoScritto << endl;    
  return ff;
}

bool controlla(const CodaIscr* pc) {
  for(int i=pc->front; i!=pc->back; i=(i+1)%MAXN)
    for(int j=(i+1)%MAXN; j!=pc->back; j=(j+1)%MAXN)
      if(i!=j && pc->iscr[i].matricola == pc->iscr[j].matricola)
        return false;
  return true;
}

bool votoPiuAlto(const CodaIscr* pc, Iscrizione* pi){
  int v = -1;
  if(pc->front == pc->back) return false;
  for(int i=pc->front; i!=pc->back; i=(i+1)%MAXN)
    if(pc->iscr[i].votoScritto > v) {
      v = pc->iscr[i].votoScritto;
      *pi = pc->iscr[i];
    }
  return true;
}
